/* -*- Mode: C; c-basic-offset:4 ; indent-tabs-mode:nil ; -*- */
/*
 *  (C) 2010 by Argonne National Laboratory.
 *      See COPYRIGHT in top-level directory.
 */
/* automatically generated
 *   by:   ./maint/genparams
 *   at:   Tue Aug 10 21:13:37 2010
 *   from: src/util/param/params.yml (md5sum fc6349efcd35a84d72533d31472f4b30)
 *
 * DO NOT EDIT!!!
 */

#include "mpiimpl.h"

/* array of category info for runtime usage */
struct MPIR_Param_category_t MPIR_Param_categories[MPIR_PARAM_NUM_CATEGORIES] = {
    { MPIR_PARAM_CATEGORY_ID_collective,
      "collective",
      "parameters that control collective communication behavior" },
    { MPIR_PARAM_CATEGORY_ID_pt2pt,
      "pt2pt",
      "parameters that control point-to-point communication behavior" },
    { MPIR_PARAM_CATEGORY_ID_intranode,
      "intranode",
      "intranode communication parameters" },
    { MPIR_PARAM_CATEGORY_ID_developer,
      "developer",
      "useful for developers working on MPICH2 itself" },
    { MPIR_PARAM_CATEGORY_ID_error_handling,
      "error_handling",
      "parameters that control error handling behavior (stack traces, aborts, etc)" },
    { MPIR_PARAM_CATEGORY_ID_debugger,
      "debugger",
      "parameters relevant to the \"MPIR\" debugger interface" },
    { MPIR_PARAM_CATEGORY_ID_threads,
      "threads",
      "multi-threading parameters" },
    { MPIR_PARAM_CATEGORY_ID_nemesis,
      "nemesis",
      "parameters that control behavior of the ch3:nemesis channel" },
};

/* array of parameter info for runtime usage */
struct MPIR_Param_t MPIR_Param_params[MPIR_PARAM_NUM_PARAMS] = {
    { MPIR_PARAM_ID_ALLTOALL_SHORT_MSG_SIZE,
      "ALLTOALL_SHORT_MSG_SIZE",
      "the short message algorithm will be used if the per-destination message size (sendcount*size(sendtype)) is <= this value",
      { MPIR_PARAM_TYPE_INT, 256, 0.0, "" } },
    { MPIR_PARAM_ID_ALLTOALL_MEDIUM_MSG_SIZE,
      "ALLTOALL_MEDIUM_MSG_SIZE",
      "the medium message algorithm will be used if the per-destination message size (sendcount*size(sendtype)) is <= this value and larger than ALLTOALL_SHORT_MSG_SIZE",
      { MPIR_PARAM_TYPE_INT, 32768, 0.0, "" } },
    { MPIR_PARAM_ID_ALLTOALL_THROTTLE,
      "ALLTOALL_THROTTLE",
      "max no. of irecvs/isends posted at a time in some alltoall algorithms. Setting it to 0 causes all irecvs/isends to be posted at once.",
      { MPIR_PARAM_TYPE_INT, 4, 0.0, "" } },
    { MPIR_PARAM_ID_NOLOCAL,
      "NOLOCAL",
      "If true, force all processes to operate as though all processes are located on another node.  For example, this disables shared memory communication hierarchical collectives.",
      { MPIR_PARAM_TYPE_BOOLEAN, 0, 0.0, "" } },
    { MPIR_PARAM_ID_NESTCHECK,
      "NESTCHECK",
      "If true, sanity check nesting levels at MPI_Finalize.",
      { MPIR_PARAM_TYPE_BOOLEAN, 1, 0.0, "" } },
    { MPIR_PARAM_ID_MEMDUMP,
      "MEMDUMP",
      "If true, list any memory that was allocated by MPICH2 and that remains allocated when MPI_Finalize completes.",
      { MPIR_PARAM_TYPE_BOOLEAN, 1, 0.0, "" } },
    { MPIR_PARAM_ID_PROCTABLE_SIZE,
      "PROCTABLE_SIZE",
      "Size of the \"MPIR\" debugger interface proctable (process table).",
      { MPIR_PARAM_TYPE_INT, 64, 0.0, "" } },
    { MPIR_PARAM_ID_PROCTABLE_PRINT,
      "PROCTABLE_PRINT",
      "If true, dump the proctable entries at MPIR_WaitForDebugger-time. (currently compile-time disabled by \"#if 0\")",
      { MPIR_PARAM_TYPE_BOOLEAN, 1, 0.0, "" } },
    { MPIR_PARAM_ID_PRINT_ERROR_STACK,
      "PRINT_ERROR_STACK",
      "If true, print an error stack trace at error handling time.",
      { MPIR_PARAM_TYPE_BOOLEAN, 1, 0.0, "" } },
    { MPIR_PARAM_ID_CHOP_ERROR_STACK,
      "CHOP_ERROR_STACK",
      "If >0, truncate error stack output lines this many characters wide.  If 0, do not truncate, and if <0 use a sensible default.",
      { MPIR_PARAM_TYPE_INT, 0, 0.0, "" } },
    { MPIR_PARAM_ID_NEM_LMT_DMA_THRESHOLD,
      "NEM_LMT_DMA_THRESHOLD",
      "Messages larger than this size will use the \"dma\" (knem) intranode LMT implementation, if it is enabled and available.",
      { MPIR_PARAM_TYPE_INT, 2097152, 0.0, "" } },
    { MPIR_PARAM_ID_NEMESIS_NETMOD,
      "NEMESIS_NETMOD",
      "If non-empty, this parameter specifies which network module should be used for communication.",
      { MPIR_PARAM_TYPE_STRING, -1, 0.0, "" } },
};

/* actual storage for parameters */
int MPIR_PARAM_ALLTOALL_SHORT_MSG_SIZE = 256;
int MPIR_PARAM_ALLTOALL_MEDIUM_MSG_SIZE = 32768;
int MPIR_PARAM_ALLTOALL_THROTTLE = 4;
int MPIR_PARAM_NOLOCAL = 0;
int MPIR_PARAM_NESTCHECK = 1;
int MPIR_PARAM_MEMDUMP = 1;
int MPIR_PARAM_PROCTABLE_SIZE = 64;
int MPIR_PARAM_PROCTABLE_PRINT = 1;
int MPIR_PARAM_PRINT_ERROR_STACK = 1;
int MPIR_PARAM_CHOP_ERROR_STACK = 0;
int MPIR_PARAM_NEM_LMT_DMA_THRESHOLD = 2097152;
const char * MPIR_PARAM_NEMESIS_NETMOD = "";

#undef FUNCNAME
#define FUNCNAME MPIR_Param_init_params
#undef FCNAME
#define FCNAME MPIU_QUOTE(FUNCNAME)
int MPIR_Param_init_params(void)
{
    int mpi_errno = MPI_SUCCESS;
    int rc;

    rc = MPL_env2int("MPICH_ALLTOALL_SHORT_MSG_SIZE", &(MPIR_PARAM_ALLTOALL_SHORT_MSG_SIZE));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_ALLTOALL_SHORT_MSG_SIZE");
    rc = MPL_env2int("MPIR_PARAM_ALLTOALL_SHORT_MSG_SIZE", &(MPIR_PARAM_ALLTOALL_SHORT_MSG_SIZE));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_ALLTOALL_SHORT_MSG_SIZE");

    rc = MPL_env2int("MPICH_ALLTOALL_MEDIUM_MSG_SIZE", &(MPIR_PARAM_ALLTOALL_MEDIUM_MSG_SIZE));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_ALLTOALL_MEDIUM_MSG_SIZE");
    rc = MPL_env2int("MPIR_PARAM_ALLTOALL_MEDIUM_MSG_SIZE", &(MPIR_PARAM_ALLTOALL_MEDIUM_MSG_SIZE));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_ALLTOALL_MEDIUM_MSG_SIZE");

    rc = MPL_env2int("MPICH_ALLTOALL_THROTTLE", &(MPIR_PARAM_ALLTOALL_THROTTLE));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_ALLTOALL_THROTTLE");
    rc = MPL_env2int("MPIR_PARAM_ALLTOALL_THROTTLE", &(MPIR_PARAM_ALLTOALL_THROTTLE));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_ALLTOALL_THROTTLE");

    rc = MPL_env2bool("MPICH_NO_LOCAL", &(MPIR_PARAM_NOLOCAL));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_NO_LOCAL");
    rc = MPL_env2bool("MPIR_PARAM_NO_LOCAL", &(MPIR_PARAM_NOLOCAL));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_NO_LOCAL");
    rc = MPL_env2bool("MPICH_NOLOCAL", &(MPIR_PARAM_NOLOCAL));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_NOLOCAL");
    rc = MPL_env2bool("MPIR_PARAM_NOLOCAL", &(MPIR_PARAM_NOLOCAL));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_NOLOCAL");

    rc = MPL_env2bool("MPICH_NEST_CHECK", &(MPIR_PARAM_NESTCHECK));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_NEST_CHECK");
    rc = MPL_env2bool("MPIR_PARAM_NEST_CHECK", &(MPIR_PARAM_NESTCHECK));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_NEST_CHECK");
    rc = MPL_env2bool("MPICH_NESTCHECK", &(MPIR_PARAM_NESTCHECK));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_NESTCHECK");
    rc = MPL_env2bool("MPIR_PARAM_NESTCHECK", &(MPIR_PARAM_NESTCHECK));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_NESTCHECK");

    rc = MPL_env2bool("MPICH_MEMDUMP", &(MPIR_PARAM_MEMDUMP));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_MEMDUMP");
    rc = MPL_env2bool("MPIR_PARAM_MEMDUMP", &(MPIR_PARAM_MEMDUMP));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_MEMDUMP");

    rc = MPL_env2int("MPICH_PROCTABLE_SIZE", &(MPIR_PARAM_PROCTABLE_SIZE));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_PROCTABLE_SIZE");
    rc = MPL_env2int("MPIR_PARAM_PROCTABLE_SIZE", &(MPIR_PARAM_PROCTABLE_SIZE));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_PROCTABLE_SIZE");

    rc = MPL_env2bool("MPICH_PROCTABLE_PRINT", &(MPIR_PARAM_PROCTABLE_PRINT));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_PROCTABLE_PRINT");
    rc = MPL_env2bool("MPIR_PARAM_PROCTABLE_PRINT", &(MPIR_PARAM_PROCTABLE_PRINT));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_PROCTABLE_PRINT");

    rc = MPL_env2bool("MPICH_PRINT_ERROR_STACK", &(MPIR_PARAM_PRINT_ERROR_STACK));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_PRINT_ERROR_STACK");
    rc = MPL_env2bool("MPIR_PARAM_PRINT_ERROR_STACK", &(MPIR_PARAM_PRINT_ERROR_STACK));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_PRINT_ERROR_STACK");

    rc = MPL_env2int("MPICH_CHOP_ERROR_STACK", &(MPIR_PARAM_CHOP_ERROR_STACK));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_CHOP_ERROR_STACK");
    rc = MPL_env2int("MPIR_PARAM_CHOP_ERROR_STACK", &(MPIR_PARAM_CHOP_ERROR_STACK));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_CHOP_ERROR_STACK");

    rc = MPL_env2int("MPICH_NEM_LMT_DMA_THRESHOLD", &(MPIR_PARAM_NEM_LMT_DMA_THRESHOLD));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_NEM_LMT_DMA_THRESHOLD");
    rc = MPL_env2int("MPIR_PARAM_NEM_LMT_DMA_THRESHOLD", &(MPIR_PARAM_NEM_LMT_DMA_THRESHOLD));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_NEM_LMT_DMA_THRESHOLD");

    rc = MPL_env2str("MPICH_NEMESIS_NETMOD", &(MPIR_PARAM_NEMESIS_NETMOD));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPICH_NEMESIS_NETMOD");
    rc = MPL_env2str("MPIR_PARAM_NEMESIS_NETMOD", &(MPIR_PARAM_NEMESIS_NETMOD));
    MPIU_ERR_CHKANDJUMP1((-1 == rc),mpi_errno,MPI_ERR_OTHER,"**envvarparse","**envvarparse %s","MPIR_PARAM_NEMESIS_NETMOD");

fn_fail:
    return mpi_errno;
}

